'From Squeak3.4gamma of ''7 January 2003'' [latest update: #5169] on 7 February 2003 at 10:57:19 pm'!
"Change Set:		8-MoreClosureFixes-ajh
Date:			7 February 2003
Author:			Anthony Hannan

More fixes.  Thanks to Tim Rowledge for find these bugs"!


!Behavior methodsFor: 'accessing' stamp: 'ajh 2/7/2003 20:17'!
decompilerClass
	"Answer a decompiler class appropriate for compiled methods of this class."

	^ Preferences compileBlocksAsClosures
		ifTrue: [Decompiler2]
		ifFalse: [Decompiler]! !


!Parser2 methodsFor: 'public access' stamp: 'ajh 2/7/2003 22:39'!
parseArgsAndTemps: aString notifying: req 
	"No initialization required.  Parse the argument, aString, notifying req if an error occurs. Otherwise, answer a two-element Array containing Arrays of strings (the argument names and temporary variable names)."

	(req notNil and: [RequestAlternateSyntaxSetting signal]) ifTrue:
		[^ (self as: DialectParser2) parseArgsAndTemps: aString notifying: req].
	aString == nil ifTrue: [^ #()].
	doitFlag _ false.               "Don't really know if a doit or not!!"
	^ self initPattern: aString
		notifying: req
		return: [:blockNode |
			self temporaries.
			blockNode tempVars collect: [:v | v name]
		]! !


!DialectParser2 methodsFor: 'as yet unclassified' stamp: 'ajh 2/7/2003 22:40'!
parseArgsAndTemps: aString notifying: req 
	"Parse the argument, aString, notifying req if an error occurs. Otherwise, 
	answer a two-element Array containing Arrays of strings (the argument 
	names and temporary variable names)."

	aString == nil ifTrue: [^ #()].
	doitFlag _ false.		"Don't really know if a doit or not!!"
	^ self initPattern: aString
		notifying: req
		return: [:blockNode |
			self temporaries.
			blockNode tempVars collect: [:v | v name]
		]! !

!DialectParser2 methodsFor: 'as yet unclassified' stamp: 'ajh 2/7/2003 22:34'!
temporaries
	" [ 'Use' (variable)* '.' ]"

	| theActualText |
	(self matchToken: #'Use') ifFalse: 
		["no temps"
		doitFlag ifTrue: [requestor
				ifNil: [tempsMark _ 1]
				ifNotNil: [tempsMark _ requestor selectionInterval first].
			^ self].
		tempsMark _ prevEnd+1.
		tempsMark > 0 ifTrue:
			[theActualText _ source contents.
			[tempsMark < theActualText size and: [(theActualText at: tempsMark) isSeparator]]
				whileTrue: [tempsMark _ tempsMark + 1]].
			^ self].
	[hereType == #word]
		whileTrue: [self declareTemp: self advance].
	(self match: #period) ifTrue: 
		[tempsMark _ prevMark.
		^ self].
	^ self expected: 'Period'! !


!TestCodeGenerator methodsFor: 'coercing' stamp: 'ajh 2/7/2003 21:27'!
ccgTVarBlock: anInteger

	| ctxtString |
	ctxtString _ Preferences compileBlocksAsClosures
		ifTrue: ['thisContext']  "thisContext refers to captured context not eval context"
		ifFalse: ['(thisContext tempAt: 1)'].  "thisContext refers to eval context"
	^ [:expr | ctxtString, ' tempAt: ', anInteger asString, ' put: (', expr, ')']! !

